/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Criacao;
import com.tabajara.base.tables.interfaces.ICriacao;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import java.sql.Date;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record3;
import org.jooq.Row3;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CriacaoRecord extends UpdatableRecordImpl<CriacaoRecord> implements VertxPojo, Record3<Integer, String, Date>, ICriacao {

    private static final long serialVersionUID = -1515643471;

    /**
     * Setter for <code>public.criacao.criaid</code>.
     */
    @Override
    public CriacaoRecord setCriaid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.criacao.criaid</code>.
     */
    @Override
    public Integer getCriaid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.criacao.criaespecie</code>.
     */
    @Override
    public CriacaoRecord setCriaespecie(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.criacao.criaespecie</code>.
     */
    @Override
    public String getCriaespecie() {
        return (String) get(1);
    }

    /**
     * Setter for <code>public.criacao.criadata</code>.
     */
    @Override
    public CriacaoRecord setCriadata(Date value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.criacao.criadata</code>.
     */
    @Override
    public Date getCriadata() {
        return (Date) get(2);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record3 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row3<Integer, String, Date> fieldsRow() {
        return (Row3) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row3<Integer, String, Date> valuesRow() {
        return (Row3) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Criacao.CRIACAO.CRIAID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return Criacao.CRIACAO.CRIAESPECIE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Date> field3() {
        return Criacao.CRIACAO.CRIADATA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getCriaid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getCriaespecie();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date component3() {
        return getCriadata();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getCriaid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getCriaespecie();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date value3() {
        return getCriadata();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CriacaoRecord value1(Integer value) {
        setCriaid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CriacaoRecord value2(String value) {
        setCriaespecie(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CriacaoRecord value3(Date value) {
        setCriadata(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CriacaoRecord values(Integer value1, String value2, Date value3) {
        value1(value1);
        value2(value2);
        value3(value3);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(ICriacao from) {
        setCriaid(from.getCriaid());
        setCriaespecie(from.getCriaespecie());
        setCriadata(from.getCriadata());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends ICriacao> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached CriacaoRecord
     */
    public CriacaoRecord() {
        super(Criacao.CRIACAO);
    }

    /**
     * Create a detached, initialised CriacaoRecord
     */
    public CriacaoRecord(Integer criaid, String criaespecie, Date criadata) {
        super(Criacao.CRIACAO);

        set(0, criaid);
        set(1, criaespecie);
        set(2, criadata);
    }

    public CriacaoRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
